var line = new Array(new Array());
var divLines = new Array();
var divToolTipTexts = new Array();
var listOfAnnotationSerialNumbers = new Array();
var maxLayer = 0;


function highlightAnnotations() {

	var pagename = wgPageName;
	var str1 = ajaxCall_standard("getHTMLContent",[pagename]);
	
	listOfAnnotationSerialNumbers = getListOfAnnotationSerialNumbers();
	
	//$("#mw-content-text").hide();
	$("#mw-content-text").css("visibility", "hidden");	
	toolTipText = null;
	//is needed for the right 
	$('#mw-content-text').css("padding-left","0px");
	$('#mw-content-text').css("padding-right","550px");
	
	//the following variables are globale and need to be reset (relevant for createDivsForToolTipTextsAndLines)
	line = null;
	line = new Array(new Array());
	divLines = new Array();
	divToolTipTexts = new Array();
	maxLayer=0;
	
	
	for (var i=0; i<listOfAnnotationSerialNumbers.length; i++) {
		var divTags = new Array();
		divTags = createDivsForToolTipTextsAndLines(listOfAnnotationSerialNumbers[i]);
		divLines[i] 		= divTags[0];
		divToolTipTexts[i] 	= divTags[1];
	}

	//create a new DOM node to which all the necessary information can be appended	
		if ($('#sta_mw-content-text')) $('#sta_mw-content-text').html("");	
		$('<div/>', {
		    id: 'sta_mw-content-text',
		}).appendTo('#bodyContent');
	
	//make the lines transparent so that they can fade in, but still use the space they need
	$("#mw-content-text").css("visibility", "hidden");		
	
	//Move element mw-content-text to the left, according to the number of lines side by side
	$('#mw-content-text').css("padding-left",(maxLayer+1)*15+"px");
	
	var paddingRight = 550-(maxLayer+1)*15;
	$('#mw-content-text').css("padding-right",paddingRight+"px");
	
	
	appendDivForHighlightAnnotation(divLines,divToolTipTexts,listOfAnnotationSerialNumbers);

	
	//Box giving instructions. Shown before user choosed an annotation
	var standardBox = '<div id="standardBox" class="STAinfoBox" style="top:10px;display:block;">'//style="top:10px;left:1000px;width:300px;height:400px;display:block">'
						+ '<b>Semantic Text Annotator</b><br><br><i>Fahre mit der Maus ueber eine Linie am linken Textrand, um eine Annotation anzuzeigen.</i></div>';

	$('#sta_mw-content-text').append(standardBox);
	
	letElementFollowScroll('standardBox');
	

	//Let the whole content fade in
	$("#sta_mw-content-text").css("visibility", "visible");
	$("#mw-content-text").css("visibility", "visible");
	$("#mw-content-text").hide();
	$("#sta_mw-content-text").hide();
	$("#mw-content-text").fadeIn('normal');
	$("#sta_mw-content-text").fadeIn('normal');
	
	//highlightAnnotations need to be called again, if the size of the window was changed	
	var flag = false;
	window.onresize = function () {
		
		window.setTimeout(
				function(){
					if(flag==false)
						highlightAnnotations();
						flag = true;
				},
				1000
		);	
	}
}


function createDivsForToolTipTextsAndLines(annotationSerialNumber) {
	
	var infoBoxCode = "{{STAinfoBox|annotationSerialNumber=" + annotationSerialNumber + "}}";
	var parsedString =  ajaxCall_standard("parseText",[infoBoxCode]);	
	var index = 0;
	
	//span-Tags mit "annotationSerialNumber+1" an Stelle vor aTag und "annotationSerialNumber+2" an Stelle hinter eTag in den Text mit Wikisyntax hinzufuegen
	//anhand der Position dieser Tags (Hoehe) wird die Position der Linie am Rand definiert
	
	//insert span tag with "annotationSerialNumber+1" at the position befor aTag and "annotationSerialNumber+2" at the position behind eTag in the text with wikisyntax
	//according to this spans the lines on the left side of the text are made
	var editTextWithSpanNode = insertNode(index,annotationSerialNumber,"span")[0];
	var newString =  ajaxCall_standard("parseText",[editTextWithSpanNode]);
	document.getElementById("mw-content-text").innerHTML = newString;
	correctMwContentText();
	
	
	//TODO: if selection start at the beginning of a new line in the text displayed in the browser 
	//(but the word must not be the first word of a new paragraph - no problem here)
	//than: offsetLeft is not 0 but the value of the ending of previous line		
	
	var posTop 		= document.getElementById(annotationSerialNumber+"1").offsetTop;//
	var posBottom 	= document.getElementById(annotationSerialNumber+"2").offsetTop + document.getElementById(annotationSerialNumber+"2").offsetHeight;//
	var posHeight	= posBottom-posTop;
	
	var posLeft = 0;
	layer = 0;
	
	for(var i=posTop; i<=posBottom; i++) {
		if(line[layer][i] == true) {
			layer = layer+1;
			i=posTop;
			if (typeof line[layer] == 'undefined')
				line[layer] = new Array();
		}
	}
	
	if (maxLayer<layer)
		maxLayer=layer;
	
	posLeft = posLeft + layer*15;
	
	//verschieben der linien nach rechts fuer bestimmte skins, weil parentelement hier ueber den gesamten bildschirm geht
	if((skin=="cologneblue")||(skin=="standard")) { //skin heisst "Classic" in preferences
		var widthMenu = document.getElementById("quickbar").offsetWidth;
		posLeft = posLeft + widthMenu + 10;
	} else if (skin=="modern") {
		var widthMenu = document.getElementById("mw_portlets").offsetWidth;
		posLeft = posLeft + widthMenu;
	} else if (skin=="simple") {
		var widthMenu = document.getElementById("column-one").offsetWidth;
		posLeft = posLeft + widthMenu + 10;
	}
	
	for(var i=posTop; i<=posBottom; i++) {
		line[layer][i]=true;
	}
	
	
	$('#'+annotationSerialNumber+"1").replaceWith($('#'+annotationSerialNumber+"1").html());
	$('#'+annotationSerialNumber+"2").replaceWith($('#'+annotationSerialNumber+"2").html());
	
	
	var result;
	result = new Array();
	result[0] = '<div id="line_'+annotationSerialNumber+'" class="STAline" style="top:'+ posTop +'px;left:'+ posLeft +'px;width:10px;height:'+ posHeight +'px;"></div>';
	
	var posTop2=$(document).scrollTop()+10+"px";
	
	result[1] = '<div id="toolTipText_'+annotationSerialNumber+'" class="STAinfoBox" style="top:'+ posTop2 +';">'
				+ "<b>Semantic Text Annotator\n</b>"
				+ parsedString+'</div>';
	
	return result;
}


function insertNode(index, annotationSerialNumber, tagName) {	
	var result = "";
	var pagename = wgPageName;
	var editText = ajaxCall_standard("getEditContent",[pagename]);
	var newString;
	var pos1;
	
	var str = "{{aTag|"+annotationSerialNumber;
	
	pos1 = editText.indexOf(str,index);
	if (pos1 == -1) {
		return [newString,pos1,annotationSerialNumber];
	}
	
	var regEx = new RegExp('\{\{eTag\\|' + annotationSerialNumber);
	var pos2 = editText.search(regEx,index);
	
	var anfang = editText.substring(0,pos1);
	var mitte = editText.substring(pos1,pos2+17);
	var ende = editText.substring(pos2+17,editText.length);
	
	newString = anfang + '<'+tagName+' id="'+ annotationSerialNumber +'1"></'+tagName+'>' + mitte + '<'+tagName+' id="'+ annotationSerialNumber +'2"></'+tagName+'>' + ende; 
	result = [newString,annotationSerialNumber];
	
	return result;
}



function appendDivForHighlightAnnotation (divLines,divToolTipTexts,listOfAnnotationSerialNumbers) {
	for (var i=0; i<divLines.length; i++) {
		$('#sta_mw-content-text').append(divLines[i]);
		$('#sta_mw-content-text').append(divToolTipTexts[i]);
		var posTop = $(document).scrollTop()+10+"px";
		$('#toolTipText_'+listOfAnnotationSerialNumbers[i]).css("top",posTop);
		showHideProperties(listOfAnnotationSerialNumbers[i]);
		
		var editButton = '<input type="button" value="Edit Annotation" id="editAnnotation_'+listOfAnnotationSerialNumbers[i]+'" my_id="'+listOfAnnotationSerialNumbers[i]+'">';
		$('#toolTipText_'+listOfAnnotationSerialNumbers[i]).append(editButton);
		$('#editAnnotation_'+listOfAnnotationSerialNumbers[i]).click(function (e) {
			changeAnnotation($(e.target).attr("my_id"));
		});
		
		var deleteButton = '<input type="button" value="Delete Annotation" id="deleteAnnotation_'+listOfAnnotationSerialNumbers[i]+'" my_id="'+listOfAnnotationSerialNumbers[i]+'">';
		$('#toolTipText_'+listOfAnnotationSerialNumbers[i]).append(deleteButton);
		$('#deleteAnnotation_'+listOfAnnotationSerialNumbers[i]).click(function (e) {
			deleteAnnotation($(e.target).attr("my_id"));
		});
						
	}

}




