function insertSpanNodeForEveryNode(annotationSerialNumber){
	var focusNode = document.getElementById(annotationSerialNumber+"1");
	moveForwardThroughNodes(focusNode,annotationSerialNumber);
	//alert($("#mw-content-text").html());
}


function moveForwardThroughNodes (focusNode,annotationSerialNumber) {
	var resultOfAddSpanToChildNodeFunction;
	//alert("moveForward");
	//alert("before 1. while");
	while (focusNode.nextSibling !== null && focusNode.nextSibling.id != annotationSerialNumber+"2"){
		//alert("before 2. while");
		while (focusNode.nextSibling !== null && focusNode.nextSibling.id != annotationSerialNumber+"2") {
			
			focusNode = focusNode.nextSibling;
			//alert("next node selected and it has nodeTye = "+focusNode.nodeType+"\nand textContent = *"+focusNode.textContent+"*\n and tagName = "+focusNode.tagName+"\n and mw-content-text:\n"+document.getElementById("mw-content-text").innerHTML);
			if (focusNode.nodeType == "3" | (focusNode.nodeType == "1" && focusNode.tagName == "BR")) {
				//alert("The node is a TextNode");
				var brFlag = (focusNode.tagName == "BR");
				resultOfAddSpanToChildNodeFunction = addSpanToChildNodes(focusNode,annotationSerialNumber);
				focusNode = resultOfAddSpanToChildNodeFunction[1];
				if(brFlag) {
					focusNode.innerHTML = "<br>";
					//alert("br tag added:" + focusNode.innerHTML);
				}
				
			} else {
				//alert("The node is NOT a TextNode");
				resultOfAddSpanToChildNodeFunction = addSpanToChildNodes(focusNode,annotationSerialNumber);
				//alert(resultOfAddSpanToChildNodeFunction);
			}
			
			//alert("end 1. while");
			if(resultOfAddSpanToChildNodeFunction[0] == true | (focusNode.nextSibling !== null && focusNode.nextSibling.id == annotationSerialNumber+"2")) {
				//alert("end of moveForwardThroughNodes because eTag was found in addSpanToChildNodes OR because next node is eTag");
				return;
			}
		}

		focusNode = focusNode.parentNode;
	}
}

function addSpanToChildNodes (focusNode,annotationSerialNumber) {
	if (focusNode.hasChildNodes()) {
		//alert("has child");
		if(focusNode.firstChild.id != annotationSerialNumber+"2") {
			//alert("select first child");
			focusNode = focusNode.firstChild;
			if (focusNode.nodeType == "3") {
				//alert("first child is a text node");
				focusNode = addSpanToChildNodes(focusNode,annotationSerialNumber)[1];
			} else {
				//alert("first child is NOT a text node");
				addSpanToChildNodes(focusNode,annotationSerialNumber);
			}
			
			//alert("now traverse the next nodes of the first child. the next node is: "+focusNode.nextSibling);
			while (focusNode.nextSibling !== null && focusNode.nextSibling.id != annotationSerialNumber+"2") {
				focusNode = focusNode.nextSibling;
				//alert("next child was choosen");
				if (focusNode.nodeType == "3") {
					//alert("the choosen child is a text node");
					focusNode = addSpanToChildNodes(focusNode,annotationSerialNumber)[1];
				} else {
					//alert("the choosen child is NOT a text node");
					addSpanToChildNodes(focusNode,annotationSerialNumber);
				}
			}
			
			if (focusNode.nextSibling !== null && focusNode.nextSibling.id == annotationSerialNumber+"2") {
				//alert("end tag was found and the exit flag is transmitted");
				var arr = new Array(true,null);
				return arr;
			}
			//alert("end traverse of childs");	
			return [false,focusNode];
		} else {
			//alert("end tag was found (first child) and the exit flag is transmitted");
			return [true,null];
		}
		
	} else {
		
		var parent = focusNode.parentNode;
		var newNode = document.createElement("span");
		var oldTextNode = document.createTextNode(focusNode.textContent);
		newNode.appendChild(oldTextNode);
		newNode.setAttribute("class","highlightedAnnotation");
		newNode.setAttribute("name",annotationSerialNumber);
				
		parent.replaceChild(newNode,focusNode);
		//alert("tag added");
		//alert("return"+newNode);
		return [false,newNode];
	}
}

